#include "qwayland-fullscreen-shell-unstable-v1.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    zwp_fullscreen_shell_v1::zwp_fullscreen_shell_v1(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    zwp_fullscreen_shell_v1::zwp_fullscreen_shell_v1(struct ::zwp_fullscreen_shell_v1 *obj)
        : m_zwp_fullscreen_shell_v1(obj)
    {
        init_listener();
    }

    zwp_fullscreen_shell_v1::zwp_fullscreen_shell_v1()
        : m_zwp_fullscreen_shell_v1(0)
    {
    }

    zwp_fullscreen_shell_v1::~zwp_fullscreen_shell_v1()
    {
    }

    void zwp_fullscreen_shell_v1::init(struct ::wl_registry *registry, int id, int version)
    {
        m_zwp_fullscreen_shell_v1 = static_cast<struct ::zwp_fullscreen_shell_v1 *>(wl_registry_bind(registry, id, &zwp_fullscreen_shell_v1_interface, version));
        init_listener();
    }

    void zwp_fullscreen_shell_v1::init(struct ::zwp_fullscreen_shell_v1 *obj)
    {
        m_zwp_fullscreen_shell_v1 = obj;
        init_listener();
    }

    bool zwp_fullscreen_shell_v1::isInitialized() const
    {
        return m_zwp_fullscreen_shell_v1 != 0;
    }

    const struct wl_interface *zwp_fullscreen_shell_v1::interface()
    {
        return &::zwp_fullscreen_shell_v1_interface;
    }

    void zwp_fullscreen_shell_v1::release()
    {
        zwp_fullscreen_shell_v1_release(
            m_zwp_fullscreen_shell_v1);
        m_zwp_fullscreen_shell_v1 = 0;
    }

    void zwp_fullscreen_shell_v1::present_surface(struct ::wl_surface *surface, uint32_t method, struct ::wl_output *output)
    {
        zwp_fullscreen_shell_v1_present_surface(
            m_zwp_fullscreen_shell_v1,
            surface,
            method,
            output);
    }

    struct ::zwp_fullscreen_shell_mode_feedback_v1 *zwp_fullscreen_shell_v1::present_surface_for_mode(struct ::wl_surface *surface, struct ::wl_output *output, int32_t framerate)
    {
        return zwp_fullscreen_shell_v1_present_surface_for_mode(
            m_zwp_fullscreen_shell_v1,
            surface,
            output,
            framerate);
    }

    void zwp_fullscreen_shell_v1::fullscreen_shell_v1_capability(uint32_t )
    {
    }

    void zwp_fullscreen_shell_v1::handle_capability(
        void *data,
        struct ::zwp_fullscreen_shell_v1 *object,
        uint32_t capability)
    {
        Q_UNUSED(object);
        static_cast<zwp_fullscreen_shell_v1 *>(data)->fullscreen_shell_v1_capability(
            capability);
    }

    const struct zwp_fullscreen_shell_v1_listener zwp_fullscreen_shell_v1::m_zwp_fullscreen_shell_v1_listener = {
        zwp_fullscreen_shell_v1::handle_capability
    };

    void zwp_fullscreen_shell_v1::init_listener()
    {
        zwp_fullscreen_shell_v1_add_listener(m_zwp_fullscreen_shell_v1, &m_zwp_fullscreen_shell_v1_listener, this);
    }

    zwp_fullscreen_shell_mode_feedback_v1::zwp_fullscreen_shell_mode_feedback_v1(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    zwp_fullscreen_shell_mode_feedback_v1::zwp_fullscreen_shell_mode_feedback_v1(struct ::zwp_fullscreen_shell_mode_feedback_v1 *obj)
        : m_zwp_fullscreen_shell_mode_feedback_v1(obj)
    {
        init_listener();
    }

    zwp_fullscreen_shell_mode_feedback_v1::zwp_fullscreen_shell_mode_feedback_v1()
        : m_zwp_fullscreen_shell_mode_feedback_v1(0)
    {
    }

    zwp_fullscreen_shell_mode_feedback_v1::~zwp_fullscreen_shell_mode_feedback_v1()
    {
    }

    void zwp_fullscreen_shell_mode_feedback_v1::init(struct ::wl_registry *registry, int id, int version)
    {
        m_zwp_fullscreen_shell_mode_feedback_v1 = static_cast<struct ::zwp_fullscreen_shell_mode_feedback_v1 *>(wl_registry_bind(registry, id, &zwp_fullscreen_shell_mode_feedback_v1_interface, version));
        init_listener();
    }

    void zwp_fullscreen_shell_mode_feedback_v1::init(struct ::zwp_fullscreen_shell_mode_feedback_v1 *obj)
    {
        m_zwp_fullscreen_shell_mode_feedback_v1 = obj;
        init_listener();
    }

    bool zwp_fullscreen_shell_mode_feedback_v1::isInitialized() const
    {
        return m_zwp_fullscreen_shell_mode_feedback_v1 != 0;
    }

    const struct wl_interface *zwp_fullscreen_shell_mode_feedback_v1::interface()
    {
        return &::zwp_fullscreen_shell_mode_feedback_v1_interface;
    }

    void zwp_fullscreen_shell_mode_feedback_v1::fullscreen_shell_mode_feedback_v1_mode_successful()
    {
    }

    void zwp_fullscreen_shell_mode_feedback_v1::handle_mode_successful(
        void *data,
        struct ::zwp_fullscreen_shell_mode_feedback_v1 *object)
    {
        Q_UNUSED(object);
        static_cast<zwp_fullscreen_shell_mode_feedback_v1 *>(data)->fullscreen_shell_mode_feedback_v1_mode_successful();
    }

    void zwp_fullscreen_shell_mode_feedback_v1::fullscreen_shell_mode_feedback_v1_mode_failed()
    {
    }

    void zwp_fullscreen_shell_mode_feedback_v1::handle_mode_failed(
        void *data,
        struct ::zwp_fullscreen_shell_mode_feedback_v1 *object)
    {
        Q_UNUSED(object);
        static_cast<zwp_fullscreen_shell_mode_feedback_v1 *>(data)->fullscreen_shell_mode_feedback_v1_mode_failed();
    }

    void zwp_fullscreen_shell_mode_feedback_v1::fullscreen_shell_mode_feedback_v1_present_cancelled()
    {
    }

    void zwp_fullscreen_shell_mode_feedback_v1::handle_present_cancelled(
        void *data,
        struct ::zwp_fullscreen_shell_mode_feedback_v1 *object)
    {
        Q_UNUSED(object);
        static_cast<zwp_fullscreen_shell_mode_feedback_v1 *>(data)->fullscreen_shell_mode_feedback_v1_present_cancelled();
    }

    const struct zwp_fullscreen_shell_mode_feedback_v1_listener zwp_fullscreen_shell_mode_feedback_v1::m_zwp_fullscreen_shell_mode_feedback_v1_listener = {
        zwp_fullscreen_shell_mode_feedback_v1::handle_mode_successful,
        zwp_fullscreen_shell_mode_feedback_v1::handle_mode_failed,
        zwp_fullscreen_shell_mode_feedback_v1::handle_present_cancelled
    };

    void zwp_fullscreen_shell_mode_feedback_v1::init_listener()
    {
        zwp_fullscreen_shell_mode_feedback_v1_add_listener(m_zwp_fullscreen_shell_mode_feedback_v1, &m_zwp_fullscreen_shell_mode_feedback_v1_listener, this);
    }
}

QT_END_NAMESPACE
