#ifndef QT_WAYLAND_GREENISLAND_OUTPUTMANAGEMENT
#define QT_WAYLAND_GREENISLAND_OUTPUTMANAGEMENT

#include "wayland-greenisland-outputmanagement-client-protocol.h"
#include <QByteArray>
#include <QString>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    class  greenisland_outputmanagement
    {
    public:
        greenisland_outputmanagement(struct ::wl_registry *registry, int id, int version);
        greenisland_outputmanagement(struct ::greenisland_outputmanagement *object);
        greenisland_outputmanagement();

        virtual ~greenisland_outputmanagement();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::greenisland_outputmanagement *object);

        struct ::greenisland_outputmanagement *object() { return m_greenisland_outputmanagement; }
        const struct ::greenisland_outputmanagement *object() const { return m_greenisland_outputmanagement; }

        bool isInitialized() const;

        static const struct ::wl_interface *interface();

        struct ::greenisland_outputconfiguration *create_configuration();

    private:
        struct ::greenisland_outputmanagement *m_greenisland_outputmanagement;
    };

    class  greenisland_outputconfiguration
    {
    public:
        greenisland_outputconfiguration(struct ::wl_registry *registry, int id, int version);
        greenisland_outputconfiguration(struct ::greenisland_outputconfiguration *object);
        greenisland_outputconfiguration();

        virtual ~greenisland_outputconfiguration();

        void init(struct ::wl_registry *registry, int id, int version);
        void init(struct ::greenisland_outputconfiguration *object);

        struct ::greenisland_outputconfiguration *object() { return m_greenisland_outputconfiguration; }
        const struct ::greenisland_outputconfiguration *object() const { return m_greenisland_outputconfiguration; }

        bool isInitialized() const;

        static const struct ::wl_interface *interface();

        void enable(struct ::wl_output *output, int32_t enable);
        void primary(struct ::wl_output *output, int32_t primary);
        void mode(struct ::wl_output *output, int32_t mode_id);
        void transform(struct ::wl_output *output, int32_t transform);
        void position(struct ::wl_output *output, int32_t x, int32_t y);
        void scale(struct ::wl_output *output, int32_t scale);
        void apply();

    protected:
        virtual void outputconfiguration_applied();
        virtual void outputconfiguration_failed();

    private:
        void init_listener();
        static const struct greenisland_outputconfiguration_listener m_greenisland_outputconfiguration_listener;
        static void handle_applied(
            void *data,
            struct ::greenisland_outputconfiguration *object);
        static void handle_failed(
            void *data,
            struct ::greenisland_outputconfiguration *object);
        struct ::greenisland_outputconfiguration *m_greenisland_outputconfiguration;
    };
}

QT_END_NAMESPACE

#endif
