#include "qwayland-greenisland-screenshooter.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    greenisland_screenshooter::greenisland_screenshooter(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_screenshooter::greenisland_screenshooter(struct ::greenisland_screenshooter *obj)
        : m_greenisland_screenshooter(obj)
    {
    }

    greenisland_screenshooter::greenisland_screenshooter()
        : m_greenisland_screenshooter(0)
    {
    }

    greenisland_screenshooter::~greenisland_screenshooter()
    {
    }

    void greenisland_screenshooter::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_screenshooter = static_cast<struct ::greenisland_screenshooter *>(wl_registry_bind(registry, id, &greenisland_screenshooter_interface, version));
    }

    void greenisland_screenshooter::init(struct ::greenisland_screenshooter *obj)
    {
        m_greenisland_screenshooter = obj;
    }

    bool greenisland_screenshooter::isInitialized() const
    {
        return m_greenisland_screenshooter != 0;
    }

    const struct wl_interface *greenisland_screenshooter::interface()
    {
        return &::greenisland_screenshooter_interface;
    }

    struct ::greenisland_screenshot *greenisland_screenshooter::capture_output(struct ::wl_output *output, const QByteArray &effects)
    {
        struct wl_array effects_data;
        effects_data.size = effects.size();
        effects_data.data = static_cast<void *>(const_cast<char *>(effects.constData()));
        effects_data.alloc = 0;

        return greenisland_screenshooter_capture_output(
            m_greenisland_screenshooter,
            output,
            &effects_data);
    }

    struct ::greenisland_screenshot *greenisland_screenshooter::capture_active(const QByteArray &effects)
    {
        struct wl_array effects_data;
        effects_data.size = effects.size();
        effects_data.data = static_cast<void *>(const_cast<char *>(effects.constData()));
        effects_data.alloc = 0;

        return greenisland_screenshooter_capture_active(
            m_greenisland_screenshooter,
            &effects_data);
    }

    struct ::greenisland_screenshot *greenisland_screenshooter::capture_surface(const QByteArray &effects)
    {
        struct wl_array effects_data;
        effects_data.size = effects.size();
        effects_data.data = static_cast<void *>(const_cast<char *>(effects.constData()));
        effects_data.alloc = 0;

        return greenisland_screenshooter_capture_surface(
            m_greenisland_screenshooter,
            &effects_data);
    }

    struct ::greenisland_screenshot *greenisland_screenshooter::capture_area(const QByteArray &effects)
    {
        struct wl_array effects_data;
        effects_data.size = effects.size();
        effects_data.data = static_cast<void *>(const_cast<char *>(effects.constData()));
        effects_data.alloc = 0;

        return greenisland_screenshooter_capture_area(
            m_greenisland_screenshooter,
            &effects_data);
    }

    greenisland_screenshot::greenisland_screenshot(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    greenisland_screenshot::greenisland_screenshot(struct ::greenisland_screenshot *obj)
        : m_greenisland_screenshot(obj)
    {
        init_listener();
    }

    greenisland_screenshot::greenisland_screenshot()
        : m_greenisland_screenshot(0)
    {
    }

    greenisland_screenshot::~greenisland_screenshot()
    {
    }

    void greenisland_screenshot::init(struct ::wl_registry *registry, int id, int version)
    {
        m_greenisland_screenshot = static_cast<struct ::greenisland_screenshot *>(wl_registry_bind(registry, id, &greenisland_screenshot_interface, version));
        init_listener();
    }

    void greenisland_screenshot::init(struct ::greenisland_screenshot *obj)
    {
        m_greenisland_screenshot = obj;
        init_listener();
    }

    bool greenisland_screenshot::isInitialized() const
    {
        return m_greenisland_screenshot != 0;
    }

    const struct wl_interface *greenisland_screenshot::interface()
    {
        return &::greenisland_screenshot_interface;
    }

    void greenisland_screenshot::destroy()
    {
        greenisland_screenshot_destroy(
            m_greenisland_screenshot);
        m_greenisland_screenshot = 0;
    }

    void greenisland_screenshot::record(struct ::wl_buffer *buffer)
    {
        greenisland_screenshot_record(
            m_greenisland_screenshot,
            buffer);
    }

    void greenisland_screenshot::screenshot_setup(int32_t , int32_t , int32_t , int32_t )
    {
    }

    void greenisland_screenshot::handle_setup(
        void *data,
        struct ::greenisland_screenshot *object,
        int32_t width,
        int32_t height,
        int32_t stride,
        int32_t format)
    {
        Q_UNUSED(object);
        static_cast<greenisland_screenshot *>(data)->screenshot_setup(
            width,
            height,
            stride,
            format);
    }

    void greenisland_screenshot::screenshot_done()
    {
    }

    void greenisland_screenshot::handle_done(
        void *data,
        struct ::greenisland_screenshot *object)
    {
        Q_UNUSED(object);
        static_cast<greenisland_screenshot *>(data)->screenshot_done();
    }

    void greenisland_screenshot::screenshot_failed(int32_t )
    {
    }

    void greenisland_screenshot::handle_failed(
        void *data,
        struct ::greenisland_screenshot *object,
        int32_t error)
    {
        Q_UNUSED(object);
        static_cast<greenisland_screenshot *>(data)->screenshot_failed(
            error);
    }

    const struct greenisland_screenshot_listener greenisland_screenshot::m_greenisland_screenshot_listener = {
        greenisland_screenshot::handle_setup,
        greenisland_screenshot::handle_done,
        greenisland_screenshot::handle_failed
    };

    void greenisland_screenshot::init_listener()
    {
        greenisland_screenshot_add_listener(m_greenisland_screenshot, &m_greenisland_screenshot_listener, this);
    }
}

QT_END_NAMESPACE
