#include "qwayland-server-greenisland-outputmanagement.h"

QT_BEGIN_NAMESPACE

namespace QtWaylandServer {
    greenisland_outputmanagement::greenisland_outputmanagement(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    greenisland_outputmanagement::greenisland_outputmanagement(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    greenisland_outputmanagement::greenisland_outputmanagement(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(resource);
    }

    greenisland_outputmanagement::greenisland_outputmanagement()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    greenisland_outputmanagement::~greenisland_outputmanagement()
    {
    }

    void greenisland_outputmanagement::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void greenisland_outputmanagement::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    greenisland_outputmanagement::Resource *greenisland_outputmanagement::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    greenisland_outputmanagement::Resource *greenisland_outputmanagement::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void greenisland_outputmanagement::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::greenisland_outputmanagement_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    const struct wl_interface *greenisland_outputmanagement::interface()
    {
        return &::greenisland_outputmanagement_interface;
    }

    greenisland_outputmanagement::Resource *greenisland_outputmanagement::outputmanagement_allocate()
    {
        return new Resource;
    }

    void greenisland_outputmanagement::outputmanagement_bind_resource(Resource *)
    {
    }

    void greenisland_outputmanagement::outputmanagement_destroy_resource(Resource *)
    {
    }

    void greenisland_outputmanagement::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        greenisland_outputmanagement *that = static_cast<greenisland_outputmanagement *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void greenisland_outputmanagement::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        greenisland_outputmanagement *that = resource->outputmanagement_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->outputmanagement_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    greenisland_outputmanagement::Resource *greenisland_outputmanagement::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::greenisland_outputmanagement_interface, version, id);
        return bind(handle);
    }

    greenisland_outputmanagement::Resource *greenisland_outputmanagement::bind(struct ::wl_resource *handle)
    {
        Resource *resource = outputmanagement_allocate();
        resource->outputmanagement_object = this;

        wl_resource_set_implementation(handle, &m_greenisland_outputmanagement_interface, resource, destroy_func);
        resource->handle = handle;
        outputmanagement_bind_resource(resource);
        return resource;
    }
    greenisland_outputmanagement::Resource *greenisland_outputmanagement::Resource::fromResource(struct ::wl_resource *resource)
    {
        if (wl_resource_instance_of(resource, &::greenisland_outputmanagement_interface, &m_greenisland_outputmanagement_interface))
            return static_cast<Resource *>(resource->data);
        return 0;
    }

    const struct ::greenisland_outputmanagement_interface greenisland_outputmanagement::m_greenisland_outputmanagement_interface = {
        greenisland_outputmanagement::handle_create_configuration
    };

    void greenisland_outputmanagement::outputmanagement_create_configuration(Resource *, uint32_t)
    {
    }


    void greenisland_outputmanagement::handle_create_configuration(
        ::wl_client *client,
        struct wl_resource *resource,
        uint32_t id)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputmanagement *>(r->outputmanagement_object)->outputmanagement_create_configuration(
            r,
            id);
    }

    greenisland_outputconfiguration::greenisland_outputconfiguration(struct ::wl_client *client, int id, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(client, id, version);
    }

    greenisland_outputconfiguration::greenisland_outputconfiguration(struct ::wl_display *display, int version)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(display, version);
    }

    greenisland_outputconfiguration::greenisland_outputconfiguration(struct ::wl_resource *resource)
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
        init(resource);
    }

    greenisland_outputconfiguration::greenisland_outputconfiguration()
        : m_resource_map()
        , m_resource(0)
        , m_global(0)
    {
    }

    greenisland_outputconfiguration::~greenisland_outputconfiguration()
    {
    }

    void greenisland_outputconfiguration::init(struct ::wl_client *client, int id, int version)
    {
        m_resource = bind(client, id, version);
    }

    void greenisland_outputconfiguration::init(struct ::wl_resource *resource)
    {
        m_resource = bind(resource);
    }

    greenisland_outputconfiguration::Resource *greenisland_outputconfiguration::add(struct ::wl_client *client, int version)
    {
        Resource *resource = bind(client, 0, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    greenisland_outputconfiguration::Resource *greenisland_outputconfiguration::add(struct ::wl_client *client, int id, int version)
    {
        Resource *resource = bind(client, id, version);
        m_resource_map.insert(client, resource);
        return resource;
    }

    void greenisland_outputconfiguration::init(struct ::wl_display *display, int version)
    {
        m_global = wl_global_create(display, &::greenisland_outputconfiguration_interface, version, this, bind_func);
        m_globalVersion = version;
    }

    const struct wl_interface *greenisland_outputconfiguration::interface()
    {
        return &::greenisland_outputconfiguration_interface;
    }

    greenisland_outputconfiguration::Resource *greenisland_outputconfiguration::outputconfiguration_allocate()
    {
        return new Resource;
    }

    void greenisland_outputconfiguration::outputconfiguration_bind_resource(Resource *)
    {
    }

    void greenisland_outputconfiguration::outputconfiguration_destroy_resource(Resource *)
    {
    }

    void greenisland_outputconfiguration::bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id)
    {
        greenisland_outputconfiguration *that = static_cast<greenisland_outputconfiguration *>(data);
        that->add(client, id, qMin(that->m_globalVersion, version));
    }

    void greenisland_outputconfiguration::destroy_func(struct ::wl_resource *client_resource)
    {
        Resource *resource = Resource::fromResource(client_resource);
        greenisland_outputconfiguration *that = resource->outputconfiguration_object;
        that->m_resource_map.remove(resource->client(), resource);
        that->outputconfiguration_destroy_resource(resource);
        delete resource;
#if !WAYLAND_VERSION_CHECK(1, 2, 0)
        free(client_resource);
#endif
    }

    greenisland_outputconfiguration::Resource *greenisland_outputconfiguration::bind(struct ::wl_client *client, uint32_t id, int version)
    {
        Q_ASSERT_X(!wl_client_get_object(client, id), "QWaylandObject bind", QStringLiteral("binding to object %1 more than once").arg(id).toLocal8Bit().constData());
        struct ::wl_resource *handle = wl_resource_create(client, &::greenisland_outputconfiguration_interface, version, id);
        return bind(handle);
    }

    greenisland_outputconfiguration::Resource *greenisland_outputconfiguration::bind(struct ::wl_resource *handle)
    {
        Resource *resource = outputconfiguration_allocate();
        resource->outputconfiguration_object = this;

        wl_resource_set_implementation(handle, &m_greenisland_outputconfiguration_interface, resource, destroy_func);
        resource->handle = handle;
        outputconfiguration_bind_resource(resource);
        return resource;
    }
    greenisland_outputconfiguration::Resource *greenisland_outputconfiguration::Resource::fromResource(struct ::wl_resource *resource)
    {
        if (wl_resource_instance_of(resource, &::greenisland_outputconfiguration_interface, &m_greenisland_outputconfiguration_interface))
            return static_cast<Resource *>(resource->data);
        return 0;
    }

    const struct ::greenisland_outputconfiguration_interface greenisland_outputconfiguration::m_greenisland_outputconfiguration_interface = {
        greenisland_outputconfiguration::handle_enable,
        greenisland_outputconfiguration::handle_primary,
        greenisland_outputconfiguration::handle_mode,
        greenisland_outputconfiguration::handle_transform,
        greenisland_outputconfiguration::handle_position,
        greenisland_outputconfiguration::handle_scale,
        greenisland_outputconfiguration::handle_apply
    };

    void greenisland_outputconfiguration::outputconfiguration_enable(Resource *, struct ::wl_resource *, int32_t )
    {
    }

    void greenisland_outputconfiguration::outputconfiguration_primary(Resource *, struct ::wl_resource *, int32_t )
    {
    }

    void greenisland_outputconfiguration::outputconfiguration_mode(Resource *, struct ::wl_resource *, int32_t )
    {
    }

    void greenisland_outputconfiguration::outputconfiguration_transform(Resource *, struct ::wl_resource *, int32_t )
    {
    }

    void greenisland_outputconfiguration::outputconfiguration_position(Resource *, struct ::wl_resource *, int32_t , int32_t )
    {
    }

    void greenisland_outputconfiguration::outputconfiguration_scale(Resource *, struct ::wl_resource *, int32_t )
    {
    }

    void greenisland_outputconfiguration::outputconfiguration_apply(Resource *)
    {
    }


    void greenisland_outputconfiguration::handle_enable(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        int32_t enable)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputconfiguration *>(r->outputconfiguration_object)->outputconfiguration_enable(
            r,
            output,
            enable);
    }

    void greenisland_outputconfiguration::handle_primary(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        int32_t primary)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputconfiguration *>(r->outputconfiguration_object)->outputconfiguration_primary(
            r,
            output,
            primary);
    }

    void greenisland_outputconfiguration::handle_mode(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        int32_t mode_id)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputconfiguration *>(r->outputconfiguration_object)->outputconfiguration_mode(
            r,
            output,
            mode_id);
    }

    void greenisland_outputconfiguration::handle_transform(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        int32_t transform)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputconfiguration *>(r->outputconfiguration_object)->outputconfiguration_transform(
            r,
            output,
            transform);
    }

    void greenisland_outputconfiguration::handle_position(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        int32_t x,
        int32_t y)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputconfiguration *>(r->outputconfiguration_object)->outputconfiguration_position(
            r,
            output,
            x,
            y);
    }

    void greenisland_outputconfiguration::handle_scale(
        ::wl_client *client,
        struct wl_resource *resource,
        struct ::wl_resource *output,
        int32_t scale)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputconfiguration *>(r->outputconfiguration_object)->outputconfiguration_scale(
            r,
            output,
            scale);
    }

    void greenisland_outputconfiguration::handle_apply(
        ::wl_client *client,
        struct wl_resource *resource)
    {
        Q_UNUSED(client);
        Resource *r = Resource::fromResource(resource);
        static_cast<greenisland_outputconfiguration *>(r->outputconfiguration_object)->outputconfiguration_apply(
            r);
    }

    void greenisland_outputconfiguration::send_applied()
    {
        send_applied(
            m_resource->handle);
    }

    void greenisland_outputconfiguration::send_applied(struct ::wl_resource *resource)
    {
        greenisland_outputconfiguration_send_applied(
            resource);
    }


    void greenisland_outputconfiguration::send_failed()
    {
        send_failed(
            m_resource->handle);
    }

    void greenisland_outputconfiguration::send_failed(struct ::wl_resource *resource)
    {
        greenisland_outputconfiguration_send_failed(
            resource);
    }

}

QT_END_NAMESPACE
